**HƯỚNG DẪN SỬ DỤNG SDK ONETARGET FLUTTER**

Link: https://pub.dev/packages/one_target_mobile_sdk

***Import***:

~Yaml: ***one_target_mobile_sdk: ^x.y.z*** (x.y.z là version)

~iOS: no

~Android:

Thêm vào gradle (level project):

    allprojects {  
      repositories {  
      google()  
      mavenCentral()  
      maven { url 'https://jitpack.io' }  
      }  
    }
Android manifest: thêm tag ***tools:replace="android:label"*** vào thẻ application.


***Cách dùng:***

1/ Khởi tạo các thông tin trước khi tracking:

    void _setupTracking() {  
      //chọn môi trường để tracking, nếu set true thì sẽ tracking ở dev, false sẽ tracking ở prod. Riêng đối với ios chỉ thực hiện tracking ở dev. Sẽ sớm bổ sung thêm prod ở next release.  
      bool isEnvironmentDev = true;  
      String writeKey = "490bf1f1-2e88-4d6d-8ec4-2bb7de74f9a8";  
      //isShowLog dùng để hiển thị log của sdk  
      bool isShowLog = false;  
      Analytics.setupTracking(  
      isEnvironmentDev,  
      writeKey,  
      isShowLog: isShowLog,  
      ).then((isSetupSuccess) {  
      _log("_setupTracking isSetupSuccess $isSetupSuccess");  
      });  
    }

2/ Tiến hành tracking bằng phương thức:

    trackEvent(String? workSpaceId, Map? identityId,  
      String? eventName, int? eventDate, Map? eventData,  
      {Function(Object?)? onResponse, Function(Object?)? onFailure})

Trong đó, bạn cần gửi các thông số workSpaceId, identityId, eventName, eventDate và eventData. Riêng 2 callback onResponse, onFailure là optional.

Ví dụ:

    void _trackEvent1() {  
      Analytics.trackEvent(  
      "490bf1f1-2e88-4d6d-8ec4-2bb7de74f9a8",  
      {  
      "user_id": "U1${DateTime.now().millisecondsSinceEpoch}",  
      "phone": "0123456789",  
      "email": "loitp@galaxy.one",  
      "deviceId": "999999999",  
      },  
      "event_name",  
      DateTime.now().millisecondsSinceEpoch,  
      {  
      "pageTitle": "Passenger Information",  
      "pagePath": "/home",  
      },  
      onResponse: (value) {  
      _log(">>>onResponse $value");  
      },  
      onFailure: (value) {  
      _log(">>>onFailure $value");  
      },  
      );  
    }


**HOW TO PUBLISH TO PUBDEV:**

Dưới đây là hướng dẫn cho maintainer SDK flutter cách publish sdk lên pubdev.  Các config đều đã được embeded, bây giờ chỉ cần thực hiện các step sau:
Kiểm tra xem sdk flutter có lỗi hay warning gì trước khi upload lên pubdev hay không.

**`dart pub publish --dry-run`**  
or  
**`flutter packages pub publish --dry-run`**

Sau đó dùng lệnh này để upload toàn bộ package lên pubdev. Lưu ý nhớ  nâng version trong yaml và update lại file CHANGELOG trước.

**`dart pub publish`**  
or  
**`flutter packages pub publish`**

***Cách build APK:***

    cd example
    flutter build apk
    
    Output sẽ ở path: /Users/loitp/StudioProjects/g1/onetarget-flutter/onetarget-flutter/example/build/app/outputs


***Tham khảo:***

*Add native lib iOS xcframework*
https://stackoverflow.com/questions/69214595/how-to-manually-add-a-xcframework-to-a-flutter-ios-plugin

*Add native lib Android jitpack*
https://gitlab.com/g1-data/onetarget-android

~~~
loitp@galaxy.one
Teams: Tran Phu Loi
Phone: 0766040293